*******************************************************************************
*               PEACEBUG, New Font                                 15.03.1995 *
*               ------------------                                            *
*                                                                             *
* written by:   Emanuel Mcklin                                               *
*               Rainfussweg 7                                                 *
*               CH-8038 Zrich                                                *
*               peace@soziologie.unizh.ch                                     *
*                                                                             *
* written with: PASM                                                          *
*******************************************************************************

                movea.l     4(sp),a0                ; Basepage
                lea         STACK(pc),sp            ; own stack

                move.l      12(a0),d0               ; TEXT length
                add.l       20(a0),d0               ; DATA length
                add.l       28(a0),d0               ; BSS length
                addi.l      #256,d0                 ; Basepage length
                move.l      d0,-(sp)
                pea         (a0)
                move.l      #$4a0000,-(sp)
                trap        #1                      ; Mshrink
                lea         12(sp),sp

                pea         SUPERVISOR(pc)
                move.w      #38,-(sp)
                trap        #14                     ; Supexec
                addq.w      #6,sp

                clr.w       -(sp)
                trap        #1                      ; Pterm0

*******************************************************************************

SUPERVISOR:     movea.l     $5a0.w,a0               ; cookie pointer
                move.l      a0,d0
                beq.s       .not_found
                subq.w      #4,a0
.search:        addq.w      #4,a0
                tst.l       (a0)                    ; search for PEACEBUGs
                beq.s       .not_found              ; cookie jar
                cmpi.l      #'PBUG',(a0)+
                bne.s       .search

                movea.l     (a0),a0                 ; gotcha
                movea.l     24(a0),a1
                tas         102(a1)                 ; set SCREEN_LOCK!
                bne.s       .screen_locked
                movea.l     32(a1),a2               ; copy 16*8 font
                lea         FONT_16(pc),a3
                move.w      #1023,d0
.copy_16:       move.l      (a3)+,(a2)+
                dbra        d0,.copy_16
                movea.l     36(a1),a2               ; copy 8*8 font
                lea         FONT_8(pc),a3
                move.w      #511,d0
.copy_8:        move.l      (a3)+,(a2)+
                dbra        d0,.copy_8
                movea.l     16(a0),a2
                jsr         (a2)                    ; NEW_FORMAT
                movea.l     20(a0),a2
                jsr         (a2)                    ; PRINT_SCREEN
                clr.b       102(a1)                 ; clear SCREEN_LOCK!
                pea         success_message(pc)
                bra.s       .message

.screen_locked: pea         screen_message(pc)      ; SCREEN_LOCK was set
                bra.s       .message

.not_found:     pea         fail_message(pc)        ; Peacebug not found
.message:       move.w      #9,-(sp)
                trap        #1                      ; Cconws
                addq.w      #6,sp
                rts

*******************************************************************************

                .DATA
success_message:dc.b        13,10,27,112,' New font installed ',27,113,13,10,0
screen_message: dc.b        13,10,' At the moment PEACEBUG''s screen interface is locked.',7,13,10,0
fail_message:   dc.b        13,10,' PEACEBUG not found',7,13,10,0
                .EVEN

*******************************************************************************

FONT_16:        dc.l        0,0,0,0,24,1013367681,-417061852,1006632960
                dc.l        60,606348519,-2117900740,402653184,12344,753304451,-433309648,0
                dc.l        3100,879215041,1731468300,0,31800,-1164781882,-695027144,2080374784
                dc.l        65278,-16974600,-84740378,-301989888,61126,-695027144,-1164781882,-301989888
                dc.l        257,50529798,-1936926632,1882202112,60,1724092817,-1652440218,1006632960
                dc.l        0,406600764,1010597631,272109568,2062,252250120,2029547520,0
                dc.l        30784,1883258880,504372240,268435456,14400,1077950464,470948884,301989888
                dc.l        328965,84741405,964260209,1631649792,10526880,-1599033160,-1667330418,-2038300672
                dc.l        8174278,-960069120,-2100902202,-1166278656,518,101057024,33949190,33554432
                dc.l        8141318,101071484,-1195327296,-1199833088,8141318,101071484,973473286,981204992
                dc.l        33478,-960054660,973473286,33554432,8173760,-1061111684,973473286,981204992
                dc.l        8173760,-1061111684,-1161378106,-1166278656,8174278,-960069120,33949190,33554432
                dc.l        8174278,-960054660,-1161378106,-1166278656,8174278,-960054660,973473286,981204992
                dc.l        0,8158726,108947046,2117861376,30784,1883273216,235932674,469762048
                dc.l        0,0,118431512,403709463,0,0,-252122108,67386452
                dc.l        285936902,120469816,0,0,64764,-50339359,-505339615,1056964608
                dc.l        0,0,0,0,6168,404232216,404226048,404226048
                dc.l        26214,1717986918,0,0,26214,-39322,-39322,0
                dc.l        404242046,1616935998,101088892,404226048,26214,1812731928,808871526,0
                dc.l        947678316,943222896,-555823924,-25821184,6168,404232216,0,0
                dc.l        1548,471341080,404232220,201719808,24624,941103128,404232248,811597824
                dc.l        26214,1010630655,1010591334,0,24,404258430,404232192,0
                dc.l        0,0,6168,404238368,0,32382,0,0
                dc.l        0,0,6168,404226048,1542,101452824,405811296,1616904192
                dc.l        15486,1717986926,1986422374,2117861376,6168,943200280,404232216,2122186752
                dc.l        15486,1717963788,404238384,2122186752,32382,202119192,202139238,2117861376
                dc.l        3084,471612476,1819049598,202113024,32382,1616936062,101058150,2117861376
                dc.l        7228,1885364348,2120640102,2117861376,32382,101059596,404238384,808452096
                dc.l        15486,1717976124,1717986918,2117861376,15486,1717993022,101058062,1010302976
                dc.l        0,404232216,6168,404226048,0,404232216,6168,404238368
                dc.l        14,473460960,1882725390,0,0,2122186752,2122186752,0
                dc.l        224,1882725390,473460960,0,15486,1717963788,404232192,404226048
                dc.l        14460,-423437610,-690175774,2117861376,6204,2120640102,2122212966,1717960704
                dc.l        31870,1717993084,1717986918,2122055680,15486,1717985376,1616930406,2117861376
                dc.l        30844,1852204646,1717986926,2088239104,32382,1616936060,1616928864,2122186752
                dc.l        32382,1616936060,1616928864,1616904192,15998,1616932462,1717986918,2117861376
                dc.l        26214,1717993086,1717986918,1717960704,32382,404232216,404232216,2122186752
                dc.l        1542,101058054,101082726,2117861376,52428,-656871184,-656880436,-960102400
                dc.l        24672,1616928864,1616928864,2122186752,50886,-286327082,-691616058,-960102400
                dc.l        26214,1719039614,2121166438,1717960704,15486,1717986918,1717986918,2117861376
                dc.l        31870,1717986918,2122080352,1616904192,15486,1717986918,1717986922,2083913728
                dc.l        63740,-858993412,-120009524,-960102400,15998,1616932920,470681094,2122055680
                dc.l        32382,404232216,404232216,404226048,26214,1717986918,1717986918,2117861376
                dc.l        26214,1717986918,1717976124,404226048,50886,-960051498,-687931666,-964558848
                dc.l        26214,1715223576,406600806,1717960704,26214,1717976124,404232216,404226048
                dc.l        32382,202119192,808476768,2122186752,7710,404232216,404232216,505282560
                dc.l        24672,1613770776,403442694,101056512,30840,404232216,404232216,2021130240
                dc.l        1052728,946629830,-973078528,0,0,0,0,-16908288
                dc.l        1080062008,470549504,0,0,0,3948038,1048471142,2117992448
                dc.l        24672,1618771558,1717986918,2122055680,0,3964000,1616928864,2117992448
                dc.l        1542,104758886,1717986918,2117992448,0,3964518,1719558240,2117992448
                dc.l        3614,404258430,404232216,404226048,0,4095590,1717986942,1040612988
                dc.l        24672,1618771558,1717986918,1717960704,6168,3684376,404232216,1010565120
                dc.l        3084,789516,202116108,202144888,49344,-1060315912,-252127028,-825884672
                dc.l        14392,404232216,404232216,1010565120,0,7143166,-690563386,-960102400
                dc.l        0,3964518,1717986918,1717960704,0,3964518,1717986918,2117861376
                dc.l        0,8158822,1717986918,2122080352,0,4095590,1717986918,2117993990
                dc.l        0,8158822,1616928864,1616904192,0,4095584,1882983942,2122055680
                dc.l        24,410943000,404232216,504233984,0,6710886,1717986918,2117992448
                dc.l        0,6710886,1717976124,404226048,0,13027030,-687931666,-964558848
                dc.l        0,6710844,1008221244,1717960704,0,6710886,1717986942,1040612988
                dc.l        0,8289804,404238384,2122186752,923672,404240624,-264759272,404229632
                dc.l        1579032,404232216,404232216,404232192,14692400,808466462,506998832,808509440
                dc.l        0,6484670,-1677721600,0,0,1579068,610681539,-16777216
                dc.l        15486,1717985376,1616930406,2117864504,26214,6710886,1717986918,2117992448
                dc.l        396312,3964518,1719558240,2117992448,1588326,3948038,1048471142,2117992448
                dc.l        26214,3948038,1048471142,2117992448,6303768,3948038,1048471142,2117992448
                dc.l        1848860,3948038,1048471142,2117992448,0,3964000,1616928864,2117995576
                dc.l        1588326,3964518,1719558240,2117992448,26214,3964518,1719558240,2117992448
                dc.l        6303768,3964518,1719558240,2117992448,26214,3684376,404232216,1010565120
                dc.l        1588326,3684376,404232216,1010565120,6303768,3684376,404232216,1010565120
                dc.l        6710808,1014916710,2122212966,1717960704,1013333016,1014916710,2122212966,1717960704
                dc.l        101455998,2120245372,2086690912,2122186752,0,7765787,2080364760,-8454144
                dc.l        4095736,-656875810,-117909288,-555876352,1588326,3964518,1717986918,2117861376
                dc.l        26214,3964518,1717986918,2117861376,6303768,3964518,1717986918,2117861376
                dc.l        1588326,6710886,1717986918,2117992448,6303768,6710886,1717986918,2117992448
                dc.l        26214,6710886,1717986942,1040612988,6710784,1014916710,1717986918,2117861376
                dc.l        6710784,1717986918,1717986918,2117861376,6168,1014916704,1617329724,404226048
                dc.l        925240,808464432,-30396368,2147418112,26214,1717993020,410916888,404226048
                dc.l        7230,1717986940,1717986918,2122080352,3614,404232318,404232216,410017792
                dc.l        396312,3948038,1048471142,2117992448,396312,3684376,404232216,1010565120
                dc.l        396312,3964518,1717986918,2117861376,396312,6710886,1717986918,2117992448
                dc.l        3308108,3964518,1717986918,1717960704,3308108,6710902,2122215014,1717960704
                dc.l        0,1010697790,2120640126,1040219648,0,1014916710,1717986942,1006665216
                dc.l        6168,1579032,808478310,2117861376,0,0,8289888,1616904192
                dc.l        0,0,8289798,101056512,6299680,589704216,812569350,202907392
                dc.l        6299680,589704216,845598234,842990080,24,402659352,404232216,404232192
                dc.l        0,6710,1826122806,436207616,0,45272,1815506136,-1342177280
                dc.l        3308108,3948038,1048471142,2117992448,3308108,3964518,1717986918,2117861376
                dc.l        81278,1717988974,1987470950,2126282752,0,20807270,1853781606,2126282752
                dc.l        0,8323035,-606086952,-8454144,32510,-656875810,-656877352,-25296896
                dc.l        1613764608,1014916710,2122212966,1717960704,846875648,1014916710,2122212966,1717960704
                dc.l        846875648,1014916710,1717986918,2117861376,6710784,0,0,0
                dc.l        396312,0,0,0,1080336,269488144,0,0
                dc.l        31434,-892679478,2047478282,168427520,31942,-2101697886,-1564835130,2080374784
                dc.l        31942,-2101695822,-1163230522,2080374784,-245670059,1358954496,0,0
                dc.l        6710784,-429496730,1717986918,-166839240,-151624090,1717986918,1717987062,-166822792
                dc.l        26230,1983790140,1852728930,0,31868,202116108,202145406,0
                dc.l        7710,101060126,909522486,0,32382,202116108,202116108,0
                dc.l        32382,107374182,1717986918,0,14392,404232216,404232216,0
                dc.l        7710,67898380,202116100,0,32382,1717986918,1717986918,0
                dc.l        28270,1717986918,1717993086,0,15420,202113024,0,0
                dc.l        15422,101058054,101072444,0,1616936574,101058062,472920112,0
                dc.l        27758,1043752550,1718513262,0,7196,202116108,202144892,0
                dc.l        65278,-20527418,-960037252,0,13878,909522486,909540990,0
                dc.l        32382,1717991030,108953214,0,28270,1714830872,470711934,0
                dc.l        15934,1040582198,909522486,808464384,31870,101058054,101058054,0
                dc.l        54998,-690555146,-960037122,0,32382,1717986918,1718019814,0
                dc.l        14392,404232216,404232216,404226048,32382,101058054,101058054,101056512
                dc.l        32318,909522486,909524542,0,32382,1717991030,101058054,101056512
                dc.l        28270,1719025166,101058054,101056512,7222,840449126,1715214412,1815609344
                dc.l        0,1052728,946629830,-973078528,0,1727502745,-278528000,0
                dc.l        0,1660345480,-1998784926,0,6204,1717986940,1717986940,1818247168
                dc.l        65150,1650483296,1616928864,1626341376,0,41876648,673720360,0
                dc.l        65278,1613764620,202911840,-16908288,0,507014342,-960051604,939524096
                dc.l        0,6710886,1717986943,1572896768,2,2130481200,808464416,0
                dc.l        8130576,2093384322,-2105358724,269515776,15486,1715618430,1111647870,1006632960
                dc.l        14444,-960051514,1814604526,1811939328,1981984,806894694,1111647870,1006632960
                dc.l        925200,2094437010,-1835870596,284221440,4112,2094437010,-1835870596,269484032
                dc.l        15998,-524238596,-54476576,2117992448,31998,-960051514,-960051514,-960102400
                dc.l        0,2122186878,2113961598,0,24,404258430,404232192,2122186752
                dc.l        24688,941362716,946888704,2122186752,1550,473460792,470681088,2122186752
                dc.l        3609,454760472,404232216,404232216,404232216,404232216,404281560,-1737490432
                dc.l        24,402685566,1579008,0,2,1048330242,1048330240,0
                dc.l        3697732,1815609344,0,0,3701884,2084044800,0,0
                dc.l        0,0,1588284,402653184,0,2035920,-800034784,0
                dc.l        12408,1212696648,0,0,12360,405823608,0,0
                dc.l        30744,806897712,0,0,16711168,0,0,0

*******************************************************************************

FONT_8:         dc.l        0,0,406611651,-417061828,1009001703,-1016710120,404551299,-2081022952
                dc.l        406351809,-1049675752,1016710119,-1013367808,-260,-101456128,-406611652,-1715214592
                dc.l        16975500,-663740416,2126762963,-607927426,406600764,2114992144,404493840,275837024
                dc.l        -255787304,-568846336,-255795237,-14804224,84215053,219773297,-1600085840,-1332175218
                dc.l        2093401600,-960070656,101058048,101058048,2080769660,-1061127168,2080769660,101088256
                dc.l        -960051588,101058048,2093006972,101088256,2093006972,-960070656,2080769536,101058048
                dc.l        2093401724,-960070656,2093401724,101088256,15366,2120629248,2019588192,2115509760
                dc.l        118431512,403709463,-252122108,67386452,285936902,120469816,-50528287,-517914880
                dc.l        0,0,404232216,402659328,1717986816,0,7143020,1828613120
                dc.l        406741052,108795904,6712344,812008960,946616432,-557025792,404232192,0
                dc.l        236722200,404491776,1882724376,406351872,6700287,1013317632,1579134,404226048
                dc.l        0,3158112,126,0,0,1579008,33950744,811614208
                dc.l        1013345910,1717976064,406329368,404258304,1013319180,405831168,2114721804,107363328
                dc.l        203177068,2114718720,2120252422,107363328,1012949116,1717976064,2114325528,808464384
                dc.l        1013343804,1717976064,1013343806,101464064,1579008,404226048,1579008,404238336
                dc.l        101455920,403441152,32256,8257536,1613764620,405823488,1013319180,402659328
                dc.l        1013345898,1851801088,406611558,2120640000,2087085692,1717992448,1013342304,1617312768
                dc.l        2020370022,1718384640,2120245372,1616936448,2120245372,1616928768,1046503534,1717976576
                dc.l        1717986942,1717986816,1008211992,404241408,101058054,107363328,1718384752,2020369920
                dc.l        1616928864,1616936448,-957415722,-960051712,1719041662,1852204544,1013343846,1717976064
                dc.l        2087085692,1616928768,1013343846,1986803200,2087085692,1818650112,1013342268,107363328
                dc.l        2115508248,404232192,1717986918,1717976576,1717986918,1715214336,-960051498,-17906176
                dc.l        1717976088,1013343744,1717986876,404232192,2114325528,811630080,504895512,404233728
                dc.l        1080045592,201720320,2014844952,404256768,272133318,0,0,65024
                dc.l        12607536,0,15366,1046887936,1616936038,1717992448,15456,1616919552
                dc.l        101072486,1717976576,15462,2120236032,472939568,808464384,15974,1715340924
                dc.l        1616936038,1717986816,402667544,404241408,402659352,404232304,1616930412,2020369920
                dc.l        941103128,404241408,60670,-691616256,31846,1717986816,15462,1717976064
                dc.l        31846,1717992544,15974,1717976582,31846,1616928768,15968,1007057920
                dc.l        1605144,404229632,26214,1717976576,26214,1715214336,50886,-696488960
                dc.l        26172,406611456,26214,1715340924,32268,405831168,236460080,404229632
                dc.l        404232216,404232216,1880627212,404254720,6353566,201326592,1579060,878870016
                dc.l        3958368,1715210296,1711276134,1717976576,202899516,2120236032,409337916,108936704
                dc.l        1711291398,1046887936,806879292,108936704,404226108,108936704,15456,1614546968
                dc.l        409337916,2120236032,1711291494,2120236032,806879292,2120236032,1711276088,404241408
                dc.l        409337912,404241408,1613758520,404241408,1711282236,1719559680,402659388,1719559680
                dc.l        202931808,2086698496,32283,2144894464,1064884446,-120004864,409337916,1717976064
                dc.l        1711276092,1717976064,806879292,1717976064,409337958,1717976576,806879334,1717976576
                dc.l        1711302246,1715340924,1711291494,1717976064,1711302246,1717976576,404241504,1614551064
                dc.l        473575548,808484352,1717976088,1008211968,473327228,1717992544,506494000,808476672
                dc.l        202899516,108936704,202899512,404241408,202899516,1717976064,202899558,1717976576
                dc.l        878182524,1717986816,878182502,1986946560,3933758,1715339324,3958374,1715208252
                dc.l        1572888,811623996,62,808464384,124,202116096,-959653834,1807975951
                dc.l        -959653834,1859559174,1572888,404232216,456551640,1815485184,-663996901,913102848
                dc.l        878182460,108936704,878182460,1717976064,37512814,1986411584,146542,1986411584
                dc.l        32475,-539460096,2144917726,-656900352,806879256,1013349990,878182424,1013349990
                dc.l        878197862,1717986876,1711276032,0,202911744,0,1062928,269484032
                dc.l        2060110538,2047478282,2126757297,-1312963714,2126757285,-1179794562,-245670059,1358954496
                dc.l        1711335014,1727399452,-161061274,1727399452,6714940,1852178432,8129548,209584128
                dc.l        1967630,506855424,8260620,202113024,8128102,1717960704,1838092,202113024
                dc.l        1969158,101056512,8271414,909508608,1617847910,1719533568,3935244,0
                dc.l        4064774,104726528,1618871814,101580800,7093862,1718484992,1838092,205258752
                dc.l        4077110,907804672,3552822,914227200,8283766,108920832,6710844,243138560
                dc.l        4064822,909389824,7867404,202113024,14079702,-687996928,8154220,1827405824
                dc.l        1838092,202116096,4064774,101058048,16672358,1719533568,8283766,101058048
                dc.l        3552796,202116096,236665958,1715263600,1063020,-964558848,1727502745,-278528000
                dc.l        30428,-925075968,473327228,1717992544,16672354,1616929016,65132,1819044936
                dc.l        -26857448,812056064,1980524,1819031552,27756,1819049920,32280,404232208
                dc.l        1008221286,1715214396,3958398,1717976064,3958374,1713661440,473331932,-856918016
                dc.l        202913876,1412968544,1080534,-690586608,1047552126,1617968640,1013343846,1717986816
                dc.l        8257662,8257536,404258328,402685440,806882328,805338624,202911768,201358848
                dc.l        924443,404232216,404232216,-656904192,404226174,1579008,3296256,843841536
                dc.l        946616320,0,947664896,0,0,404226048,3864,-663736320
                dc.l        946629740,1811939328,946608176,2080374784,2014066700,2013265920,16646144,0

*******************************************************************************

                .BSS
                ds.b        1024
STACK:          .END
